## ncbi-blast+ 2.16.0+ds

=== c++/src/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 684489 2024-06-25 12:36:39Z blastadm $
#############################################################################

cmake_minimum_required(VERSION 3.15)
if ("${PROJECT_NAME}" STREQUAL "")
    project(ncbi_cpp)
endif()
include(${CMAKE_CURRENT_LIST_DIR}/build-system/cmake/CMakeLists.top_builddir.txt)

=== c++/src/app/CMakeLists.txt ===
# $Id: CMakeLists.txt 669920 2023-07-13 15:40:22Z ivanov $

NCBI_add_subdirectory(
  agp_validate
  agpconvert
  annotwriter
  asn2asn
  asn2fasta
  asn2flat
  asn_cache
  asn_cleanup
  asnval
  bdb_env_keeper
  biosample_chk
  blast
  blastdb
  blastvdb
  bsdiff
  compart
  convert_seq
  discrepancy_report
  dustmasker
  flat2asn
  formatguess
  gap_stats
  gi2taxid
  gnomon
  grid
  hfilter
  id1_fetch
  id2_fetch
  idfetch
  idmapper
  igblast
  lds2_indexer
  multireader
  multipattern
  ncbi_encrypt
  netschedule
  netstorage
  nmer_repeats
  nw_aligner
  objextract
  objmgr
  prt2fsm
  read_blast_result
  segmasker
  speedtest
  splign
  srcchk
  ssub_fork
  streamtest
  table2asn
  tableval
  vecscreen
  winmasker
)

NCBI_add_subdirectory(
  dblb
  feat_import
  gff_deconcat
  magicblast
  netcache
  pub_report
  rmblastn
  split_cache
  sub_fuse
  tls
  wig2table
  pubseq_gateway
)

=== c++/src/connect/CMakeLists.txt ===
# $Id: CMakeLists.txt 666499 2023-04-26 18:28:29Z lavr $

# The connect library uses a split between a shared C toolkit library and an
# independent C++ toolkit library
# These variables capture the split

if (UNIX)
    set(lbsm_src ncbi_lbsm ncbi_lbsm_ipc)
endif()

set(SRC_TLS
    ncbi_gnutls ncbi_mbedtls ncbi_tls
    mbedtls/aes mbedtls/aesni mbedtls/arc4 mbedtls/aria
    mbedtls/asn1parse mbedtls/asn1write mbedtls/base64 mbedtls/bignum
    mbedtls/blowfish mbedtls/camellia mbedtls/ccm mbedtls/chacha20
    mbedtls/chachapoly mbedtls/cipher mbedtls/cipher_wrap
    mbedtls/cmac mbedtls/constant_time mbedtls/ctr_drbg mbedtls/des
    mbedtls/dhm mbedtls/ecdh mbedtls/ecdsa mbedtls/ecjpake mbedtls/ecp
    mbedtls/ecp_curves mbedtls/entropy mbedtls/entropy_poll
    mbedtls/error mbedtls/gcm mbedtls/havege mbedtls/hkdf
    mbedtls/hmac_drbg mbedtls/md mbedtls/md2 mbedtls/md4
    mbedtls/mbedtls_md5 mbedtls/memory_buffer_alloc mbedtls/mps_reader
    mbedtls/mps_trace mbedtls/nist_kw mbedtls/oid mbedtls/padlock
    mbedtls/pem mbedtls/pk mbedtls/pk_wrap mbedtls/pkcs12
    mbedtls/pkcs5 mbedtls/pkparse mbedtls/pkwrite mbedtls/platform
    mbedtls/platform_util mbedtls/poly1305 mbedtls/psa_crypto
    mbedtls/psa_crypto_aead mbedtls/psa_crypto_cipher
    mbedtls/psa_crypto_client mbedtls/psa_crypto_driver_wrappers
    mbedtls/psa_crypto_ecp mbedtls/psa_crypto_hash
    mbedtls/psa_crypto_mac mbedtls/psa_crypto_rsa
    mbedtls/psa_crypto_se mbedtls/psa_crypto_slot_management
    mbedtls/psa_crypto_storage mbedtls/psa_its_file mbedtls/ripemd160
    mbedtls/rsa mbedtls/rsa_internal mbedtls/sha1 mbedtls/sha256
    mbedtls/sha512 mbedtls/threading mbedtls/timing
    mbedtls/mbedtls_version mbedtls/version_features mbedtls/xtea
    mbedtls/certs mbedtls/pkcs11 mbedtls/x509 mbedtls/x509_create
    mbedtls/x509_crl mbedtls/x509_crt mbedtls/x509_csr
    mbedtls/x509write_crt mbedtls/x509write_csr
    mbedtls/debug mbedtls/net_sockets mbedtls/ssl_cache
    mbedtls/ssl_ciphersuites mbedtls/ssl_cli mbedtls/ssl_cookie
    mbedtls/ssl_msg mbedtls/ssl_srv mbedtls/ssl_ticket mbedtls/ssl_tls
    mbedtls/ssl_tls13_keys
    )

set(SRC_C
    ncbi_ansi_ext ncbi_types ncbi_core ncbi_priv ncbi_util
    ncbi_buffer ncbi_socket ncbi_connector ncbi_connection
    ncbi_connutil ncbi_ipv6 ncbi_server_info ncbi_host_info
    ncbi_service ncbi_sendmail ncbi_base64 ncbi_heapmgr ncbi_lb
    ncbi_socket_connector ncbi_file_connector ncbi_http_connector
    ncbi_memory_connector ncbi_service_connector ncbi_ftp_connector
    ncbi_version ncbi_iprange ncbi_local ncbi_lbsmd ncbi_dispd
    ncbi_linkerd ncbi_namerd parson
    ncbi_localip ncbi_lbdns
    ${lbsm_src}
    )

set(SRC_CXX
    ncbi_socket_cxx ncbi_core_cxx email_diag_handler
    ncbi_conn_streambuf ncbi_conn_stream ncbi_conn_test
    ncbi_misc ncbi_namedpipe ncbi_namedpipe_connector
    ncbi_pipe ncbi_pipe_connector ncbi_conn_reader_writer
    ncbi_userhost ncbi_http_session ncbi_monkey
    ncbi_service_cxx ncbi_localip_cxx ncbi_blowfish ncbi_usage_report
    connect_misc
    ${SRC_TLS}
    )

NCBI_disable_pch()
NCBI_add_library(connssl connect xxconnect xxconnect2 xconnect xthrserv)
NCBI_add_subdirectory(services ext test)

=== c++/src/corelib/CMakeLists.txt ===
# $Id: CMakeLists.txt 636432 2021-08-24 14:28:12Z grichenk $

NCBI_project_tags(core)
NCBI_add_library(corelib test_mt test_boost)
NCBI_add_subdirectory(test)
NCBI_add_subdirectory(jaeger)

=== c++/src/db/CMakeLists.txt ===
# $Id: CMakeLists.txt 621588 2020-12-14 19:26:57Z ivanov $

NCBI_add_subdirectory(bdb sqlite)

=== c++/src/objtools/CMakeLists.txt ===
# $Id: CMakeLists.txt 680762 2024-03-27 13:50:01Z ivanov $

NCBI_add_subdirectory(
  unit_test_util readers blast lds2 data_loaders simple
  alnmgr cddalignview test manip cleanup format edit 
  huge_asn validator
  asniotest align seqmasks_io eutils
  align_format snputil uudutil variation writers pubseq_gateway
  logging import flatfile
)

=== c++/src/util/CMakeLists.txt ===
# $Id: CMakeLists.txt 622908 2021-01-05 18:13:34Z merezhuk $

NCBI_add_library(util)
NCBI_add_subdirectory(
    bitset 
    regexp 
    xregexp 
    compress 
    diff 
    image 
    tables 
    sequtil 
    qparse 
    lmdb 
    lmdbxx 
    test 
    demo
    profile
)

=== c++/src/algo/winmask/CMakeLists.txt ===
# $Id: CMakeLists.txt 621774 2020-12-16 19:29:59Z ivanov $

NCBI_add_library(xalgowinmask)

=== c++/src/app/blast/CMakeLists.txt ===
# $Id: CMakeLists.txt 683932 2024-06-10 12:08:12Z ivanov $

NCBI_add_library(blast_app_util)
NCBI_add_app(
  blastp
  blastn
  blastx
  tblastn
  tblastx
  psiblast
  rpsblast
  rpstblastn
  blast_formatter
  deltablast
  seedtop
)

NCBI_project_watchers(camacho madden fongah2)

=== c++/src/app/blastdb/CMakeLists.txt ===
# $Id: CMakeLists.txt 659133 2022-11-16 18:03:53Z fongah2 $

NCBI_add_app(
  blastdbcmd makeblastdb blastdb_aliastool blastdbcheck convert2blastmask
  blastdbcp makeprofiledb blastdb_convert blastdb_path makeclusterdb
)

=== c++/src/app/blastvdb/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 643194 2022-01-06 14:19:06Z grichenk $
#############################################################################

NCBI_add_app(blastn_vdb tblastn_vdb blast_vdb_cmd blast_formatter_vdb)

=== c++/src/connect/services/CMakeLists.txt ===
# $Id: CMakeLists.txt 621390 2020-12-10 18:54:37Z ivanov $

NCBI_project_tags(grid)
NCBI_add_library(xconnserv ncbi_xcache_netcache ncbi_xblobstorage_netcache)
NCBI_add_subdirectory(test)

=== debian/changelog ===
ncbi-blast+ (2.16.0+ds-7) unstable; urgency=medium

  * debian/control: Build-depend on libncbi-vdb-dev where available
    (amd64, arm64, and x32).
  * debian/copyright: Overhaul with much help from licenserecon (lrc).
  * debian/patches/fix_bm_for_gcc15 (new): Cherry-pick a BitMagic fix
    needed for modern compilers, adjusting the path appropriately.'
    (Closes: #1097434.)
  * debian/rules: Build against (packaged!) VDB where available, using
    logic cribbed from ncbi-igblast.  (Closes: #1100037.)
  * Standards-Version: 4.7.2 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 03 May 2025 23:42:51 -0400

ncbi-blast+ (2.16.0+ds-6) unstable; urgency=medium

  * debian/control: Reinstate big-endian builds, which can be salvaged
    adequately well.
  * debian/patches/big_endian_workaround (new): On big-endian
    architectures, roll makeblastdb's and makeprofiledb's default
    blastdb_version back to 4 pending a proper fix.  Some things,
    including in particular q2-feature-classifier, will still explicitly
    request version 5, but everything else should be OK.  (See #1077777.)
  * debian/rules: Try disabling optimization altogether on sh4.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 06 Aug 2024 21:45:09 -0400

ncbi-blast+ (2.16.0+ds-5) unstable; urgency=medium

  * debian/control: Forbid builds for big-endian architectures, at least
    for now.  They nominally succeed, but two dependent autopkgtests (for
    cct and kleborate) have started failing on s390x, and there's no
    evidence that other BE architectures fare any better.  (See #1077777.)
  * debian/rules:
    - Try building with -fsection-anchors on alpha in hopes of satisfying
      the GOT size limit there too.
    - Extend -O1 cap to sh4, which still encountered VM exhaustion.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 04 Aug 2024 16:04:32 -0400

ncbi-blast+ (2.16.0+ds-4) unstable; urgency=medium

  * debian/rules:
    - Move architecture.mk inclusion to the very top for the sake of
      hypothetical builds bypassing dpkg-buildpackage.
    - Compile with -ffunction-sections on hppa and -mxgot on mips*
      (mips64el in practice) due to having outgrown default settings.
    - Disable parallel building on sh4 in hopes of avoiding buildd virtual
      memory exhaustion.

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 27 Jul 2024 22:38:52 -0400

ncbi-blast+ (2.16.0+ds-3) unstable; urgency=medium

  * debian/rules: Fix typo (missing parenthesis).

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 26 Jul 2024 15:37:28 -0400

ncbi-blast+ (2.16.0+ds-2) unstable; urgency=medium

  * debian/patches/hurd_fixes: Extend to ncbi_localip.c, which otherwise
    accommodates PATH_MAX's absence only under Windows.
  * debian/rules: Link with -latomic on most 32-bit architectures
    (excepting only x86 and armhf, which succeed as is).

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 26 Jul 2024 14:54:55 -0400

ncbi-blast+ (2.16.0+ds-1) unstable; urgency=medium

  * New upstream release, which should be (more than) new enough for
    recent q2-feature-classifier.  (Closes: #1074316.)
  * debian/control:
    - Build against libnghttp2-dev, libsqlite3-dev, and libuv1-dev, newly
      needed.
    - Build against autoconf2.69.
    - Build against libpcre2-dev, as enabled by debian/patches/allow_pcre2.
    - Stop building against 2to3, which may not be around much longer.
  * debian/patches: Update for new release, mostly formally.
  * debian/patches/2to3 (new): Cache 2to3 diff for
    windowmasker_2.2.22_adapter.
  * debian/patches/allow_pcre2 (new): Allow use of PCRE2.
  * debian/patches/series:
    - Move system_mbedtls_only up in conjunction with incorporating part
      of an upstream patch needed by support_mbedtls3.
    - Comment out reprobuild; I'm all for reproducibility, but the package
      already automatically builds with flags that make __FILE__ relative,
      and many of its uses are in header-defined macros that intend to
      pick up their callers' paths.
  * debian/patches/support_mbedtls3 (new): Support (but don't require)
    Mbed TLS 3.x.  (Closes: #1075867.)
  * debian/patches/system_mbedtls: Extend to cover ncbi_mbedtls.c (as in
    https://github.com/ncbi/ncbi-cxx-toolkit-public/commit/f9c7297dd1)
    and Makefile.xxconnect2.lib.
  * debian/rules:
    - Regenerate configure and config.h.in with Autoconf 2.69.
    - Build against PCRE2, as enabled by debian/patches/allow_pcre2.
      (Closes: #891197.)
    - Tune flags: Add --without-strip to make --with-symbols effective;
      switch off warnings from __DATE__/__TIME__ usage, since
      dpkg-buildpackage's SOURCE_DATE_EPOCH injection should suffice.
    - Extend generated-sources cleanup to objtools/eutils (not entirely
      straightforward due to input format variation).
    - Drop build-time 2to3 invocation in favor of debian/patches/2to3.
  * debian/source/lintian-overrides: No more rapidjson10 (just ...11).
  * Standards-Version: 4.7.0 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 25 Jul 2024 20:07:36 -0400

=== debian/control ===
Source: ncbi-blast+
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>,
           Andreas Tille <tille@debian.org>,
           Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               autoconf2.69
Build-Depends-Arch: libboost-test-dev,
                    libbz2-dev,
                    libc-dev-bin,
                    libgnutls28-dev,
                    liblmdb-dev,
                    libmbedtls-dev,
                    libncbi-vdb-dev [amd64 arm64 x32],
                    libnghttp2-dev,
                    libpcre2-dev,
                    libsqlite3-dev,
                    libuv1-dev,
                    time,
                    zlib1g-dev,
                    procps
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/ncbi-blastplus
Vcs-Git: https://salsa.debian.org/med-team/ncbi-blastplus.git
Homepage: https://www.ncbi.nlm.nih.gov/IEB/ToolBox/CPP_DOC/
Rules-Requires-Root: no

Package: ncbi-blast+
Architecture: any
Multi-Arch: foreign
Depends: ncbi-data,
         python3,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Enhances: t-coffee
Description: next generation suite of BLAST sequence search tools
 The Basic Local Alignment Search Tool (BLAST) is the most widely
 used sequence similarity tool. There are versions of BLAST that
 compare protein queries to protein databases, nucleotide queries
 to nucleotide databases, as well as versions that translate nucleotide
 queries or databases in all six frames and compare to protein databases
 or queries.
 PSI-BLAST produces a position-specific-scoring-matrix (PSSM) starting
 with a protein query, and then uses that PSSM to perform further searches.
 It is also possible to compare a protein or nucleotide query to a
 database of PSSM’s.
 The NCBI supports a BLAST web page at blast.ncbi.nlm.nih.gov as well as
 a network service.

Package: ncbi-blast+-legacy
Architecture: all
Multi-Arch: foreign
Depends: ncbi-blast+,
         ${misc:Depends}
Description: NCBI Blast legacy call script
 This package adds some fake scripts to call NCBI+ programs
 with the NCBI blast command line. It makes use of the
 legacy_blast script in ncbi-blast+ package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export HOME=$(CURDIR)/fakehome

NUMJOBS=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  ifneq (sh4,$(DEB_BUILD_ARCH))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  endif
endif

DEB_CONFIGURE_COMMON_FLAGS=--without-autodep --without-makefile-auto-update \
    --with-flat-makefile --without-caution --without-dbapi --without-lzo \
    --without-debug --without-sse42
DEB_CONFIGURE_EXTRA_FLAGS=$(DEB_CONFIGURE_COMMON_FLAGS) --with-dll --with-mt \
    --with-runpath=/usr/lib/ncbi-blast+ --with-build-root=BUILD \
    --with-mbedtls --with-pcre2

ifneq (,$(filter amd64 arm64 x32,$(DEB_HOST_ARCH)))
 VDB_SUBTREES=os/$(DEB_HOST_ARCH_OS) os/unix cc/gcc/$(DEB_HOST_GNU_CPU) cc/gcc
 VDB_INC=-I/usr/include/ncbi-vdb
 VDB_INCLUDE=$(VDB_INC) $(VDB_SUBTREES:%=$(VDB_INC)/%)
 DEB_CONFIGURE_COMMON_FLAGS += --with-vdb=/usr VDB_INCLUDE="$(VDB_INCLUDE)"
else
 DEB_CONFIGURE_COMMON_FLAGS += --without-downloaded-vdb
endif


proj=algo/blast/ app/ objmgr/ objtools/align_format/ objtools/blast/

#ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
DEB_CONFIGURE_EXTRA_FLAGS += --without-strip --with-symbols
#endif

#export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie reproducible=-timeless
export DEB_CFLAGS_MAINT_APPEND=-Wall -pedantic

ifeq ($(DEB_HOST_ARCH_BITS),32)
  ifeq (,$(filter armhf %i386 x32,$(DEB_HOST_ARCH)))
    export LIBS=-latomic
  endif
endif

ifeq (alpha,$(DEB_HOST_ARCH))
  export DEB_CFLAGS_MAINT_APPEND   += -fsection-anchors
  export DEB_CXXFLAGS_MAINT_APPEND += -fsection-anchors
endif
ifeq (hppa,$(DEB_HOST_ARCH))
  export DEB_CFLAGS_MAINT_APPEND   += -ffunction-sections
  export DEB_CXXFLAGS_MAINT_APPEND += -ffunction-sections
endif
# Down to mips64el in practice, but easy enough to generalize
ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
  export DEB_CFLAGS_MAINT_APPEND   += -mxgot
  export DEB_CXXFLAGS_MAINT_APPEND += -mxgot
endif

include /usr/share/dpkg/buildflags.mk

ifneq (,$(filter mips%,$(DEB_HOST_ARCH)))
CXXFLAGS := $(CXXFLAGS:-O%=-O)
DEB_CONFIGURE_EXTRA_FLAGS += FAST_CXXFLAGS=-O
endif
ifeq (sh4,$(DEB_HOST_ARCH))
DEB_CONFIGURE_COMMON_FLAGS += --without-optimization
endif

export CFLAGS CPPFLAGS CXXFLAGS LDFLAGS MAKE

# used for run_with_lock
DEB_CONFIGURE_COMMON_FLAGS +=  CFLAGS_FOR_BUILD="$(CFLAGS) -fPIE"
DEB_CONFIGURE_COMMON_FLAGS += LDFLAGS_FOR_BUILD="$(LDFLAGS)"

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
NATIVE=.native
DEB_CONFIGURE_EXTRA_FLAGS += --build=$(DEB_BUILD_GNU_TYPE) \
    --host=$(DEB_HOST_GNU_TYPE)
NATIVE_BINDIR=$(CURDIR)/c++/BUILD$(NATIVE)/bin
PREBUILT_DATATOOL_EXE=$(NATIVE_BINDIR)/datatool
PREBUILT_PTB_EXE=$(NATIVE_BINDIR)/project_tree_builder
export PREBUILT_DATATOOL_EXE PREBUILT_PTB_EXE

$(PREBUILT_DATATOOL_EXE):
	cd c++  &&  PREBUILT_PTB_EXE=bootstrap \
            ./configure $(DEB_CONFIGURE_COMMON_FLAGS) --without-objects \
            --without-algo --without-app --with-build-root=BUILD.native  ||  \
            (tail -v -n +0 config.log BUILD.native/status/config.log; exit 1)
	make -j$(NUMJOBS) -C c++/BUILD$(NATIVE)/build -f Makefile.flat \
	    datatool.exe
endif

override_dh_autoreconf:
	cd c++  && \
	    autoheader2.69 -Isrc/build-system src/build-system/configure.ac \
	    &&  cd src/build-system  &&  autoconf2.69

override_dh_auto_configure-indep:;
override_dh_auto_configure-arch: $(PREBUILT_DATATOOL_EXE)
	mkdir -p $(HOME)
	cd c++  &&  CONFIG_SHELL=/bin/bash \
            ./configure $(DEB_CONFIGURE_EXTRA_FLAGS) \
	    ||  (tail -v -n +0 config.log BUILD/status/config.log; exit 1)

override_dh_auto_build-arch:
	cd c++/BUILD/build  && \
	    make -j$(NUMJOBS) -f Makefile.flat all_projects="$(proj)"
#	   make all_r

override_dh_auto_build-indep:
	echo "Save time and do nothing for architecture independent builds"

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	-dh_auto_test
	-c++/BUILD/build/check.sh concat_err
	-cat c++/BUILD/build/check.sh.out_err
endif

instroot = debian/ncbi-blast+/usr
leg_bin = debian/ncbi-blast+-legacy/usr/bin
override_dh_auto_install-arch:
	# cp c++/BUILD/lib/*.so $(instroot)/lib/ncbi-blast+/
	cp c++/BUILD/bin/*    $(instroot)/bin/

override_dh_auto_install-indep:
	echo "Nothing to do for architecture independant installs"

override_dh_install-arch:
	# dh_install
	mv $(instroot)/bin/rpsblast $(instroot)/bin/rpsblast+
	mv $(instroot)/bin/seedtop $(instroot)/bin/seedtop+
	mv $(instroot)/bin/get_species_taxids.sh \
	    $(instroot)/bin/get_species_taxids
	mv $(instroot)/bin/cleanup-blastdb-volumes.py \
	    $(instroot)/bin/cleanup-blastdb-volumes
	mv $(instroot)/bin/legacy_blast.pl   $(instroot)/bin/legacy_blast
	mv $(instroot)/bin/update_blastdb.pl $(instroot)/bin/update_blastdb
	sed -e '1s/$$/3/' $(instroot)/bin/windowmasker_2.2.22_adapter.py \
	   > $(instroot)/bin/windowmasker_2.2.22_adapter
	chmod +x $(instroot)/bin/windowmasker_2.2.22_adapter
	rm $(instroot)/bin/windowmasker_2.2.22_adapter.py*
# Clean up tests, demos, and internal build tools
	rm -f $(instroot)/bin/*test* $(instroot)/bin/seqdb_demo \
	    $(instroot)/bin/datatool $(instroot)/bin/run_with_lock \
	    $(instroot)/bin/project_tree_builder
	mkdir c++/BUILD/lib.observed
	d=$(instroot)/bin; \
	while :; do \
	    (for x in $$d/*; do \
	        readelf -d $$x 2>/dev/null \
	        | sed -ne 's/.*NEEDED.* \[\(.*\)]$$/\1/p'; \
            done; rm -f c++/BUILD/lib.observed/*) | sort -u | while read l; do \
	        [ -f $(instroot)/lib/ncbi-blast+/$$l \
	          -o \! -f c++/BUILD/lib/$$l ]  || \
	            cp -av c++/BUILD/lib/$$l c++/BUILD/lib.observed/; \
	    done; \
	    [ -n "$$(ls c++/BUILD/lib.observed)" ] || break; \
	    echo ------------------------------------------------------------; \
	    cp -a c++/BUILD/lib.observed/* $(instroot)/lib/ncbi-blast+; \
	    d=c++/BUILD/lib.observed; \
	done

override_dh_install-indep:
	#if test -d $(leg_bin); then cp debian/legacy/legacy.sh $(leg_bin)/; fi
	for x in blastall megablast blastpgp bl2seq rpsblast fastacmd formatdb \
	         seedtop; do \
	    sed -e "s/.{.*}/$$x/" debian/legacy/legacy.sh > $(leg_bin)/$$x; \
	    chmod +x $(leg_bin)/$$x; \
	done

NEW_MODULE = $(CURDIR)/c++/BUILD$(NATIVE)/build/new_module.sh
override_dh_clean:
	cp c++/src/util/lmdb/Makefile.orig c++/src/util/lmdb/Makefile.orig.save
	cp c++/src/util/lmdbxx/Makefile.orig c++/src/util/lmdbxx/Makefile.orig.save
	cp c++/src/util/lmdbxx/lmdb++.h.orig c++/src/util/lmdbxx/lmdb++.h.orig.save

	cp c++/configure.orig configure.orig.save
	dh_clean
	#Tricky - for each module directory there may be several module files
	#or there may be none but then there is still a module named after the
	#directory.  Clean everything!
	-for x in c++/src/objects/* ; do \
	    (cd "$$x"  && ( \
		mods="`echo *.module`" ; \
		[ "$${mods#*\*}" = "$$mods" ] || mods="`basename $$x`" ; \
		for mod in $$mods ; do \
	            $(NEW_MODULE) $$mod purge_sources ; \
		done ) ; \
	    ) ; \
	done
	-for x in c++/src/objtools/eutils/* ; do \
	    (cd "$$x"  && ( \
		mods="`echo *.module`" ; \
		[ "$${mods#*\*}" = "$$mods" ] || mods="`basename $$x`" ; \
		for mod in $$mods ; do \
	            $(NEW_MODULE) --dtd $$mod purge_sources ; \
		done ) ; \
	    ) ; \
	done
	-cd c++/src/objtools/eutils/efetch  && \
	     $(NEW_MODULE) --xsd efetch purge_sources
	rm -rf c++/compilers/dll c++/config.log c++/Makefile
	rm -f c++/configure.lineno c++/src/objects/blastxml/blastxml.module
	rm -f c++/include/common/ncbi_revision.h
	find -name check_exec.pid -delete
	rm -rf c++/BUILD c++/BUILD.native fakehome
	mv configure.orig.save c++/configure.orig
	mv c++/src/util/lmdb/Makefile.orig.save c++/src/util/lmdb/Makefile.orig
	mv c++/src/util/lmdbxx/Makefile.orig.save c++/src/util/lmdbxx/Makefile.orig
	mv c++/src/util/lmdbxx/lmdb++.h.orig.save c++/src/util/lmdbxx/lmdb++.h.orig

%:

## ncbi-blast+ 2.17.0+ds

=== c++/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #############################################################################
-# $Id: CMakeLists.txt 684489 2024-06-25 12:36:39Z blastadm $
+# $Id: CMakeLists.txt 699179 2025-07-01 12:49:21Z blastadm $
 #############################################################################
 
 cmake_minimum_required(VERSION 3.15)

=== c++/src/app/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: CMakeLists.txt 669920 2023-07-13 15:40:22Z ivanov $
+# $Id: CMakeLists.txt 669752 2023-07-10 16:31:12Z mozese2 $
 
 NCBI_add_subdirectory(
   agp_validate

=== c++/src/cgi/CMakeLists.txt ===
# $Id: CMakeLists.txt 696030 2025-04-07 12:59:48Z ivanov $

NCBI_project_tags(web)
NCBI_add_library(cgi fcgi fcgi_st fcgi_mt)
NCBI_add_subdirectory(test)
#NCBI_add_subdirectory(demo)

=== c++/src/connect/CMakeLists.txt ===
# $Id: CMakeLists.txt 696923 2025-04-29 12:16:42Z ivanov $

# The connect library uses a split between a shared C toolkit library and an
# independent C++ toolkit library
# These variables capture the split

if (UNIX)
    set(lbsm_src ncbi_lbsm ncbi_lbsm_ipc)
endif()

set(SRC_MBED
    aes aesce aesni aria asn1parse asn1write base64 bignum bignum_core
    bignum_mod bignum_mod_raw block_cipher camellia ccm chacha20
    chachapoly cipher cipher_wrap cmac constant_time ctr_drbg debug
    des dhm ecdh ecdsa ecjpake ecp ecp_curves ecp_curves_new entropy
    entropy_poll error gcm hkdf hmac_drbg lmots lms mbedtls_md5
    mbedtls_version md memory_buffer_alloc mps_reader mps_trace
    net_sockets nist_kw oid padlock pem pk pk_ecc pk_wrap pkcs12 pkcs5
    pkcs7 pkparse pkwrite platform platform_util poly1305 psa_crypto
    psa_crypto_aead psa_crypto_cipher psa_crypto_client
    psa_crypto_driver_wrappers_no_static psa_crypto_ecp
    psa_crypto_ffdh psa_crypto_hash psa_crypto_mac psa_crypto_pake
    psa_crypto_rsa psa_crypto_se psa_crypto_slot_management
    psa_crypto_storage psa_its_file psa_util ripemd160 rsa
    rsa_alt_helpers sha1 sha256 sha3 sha512 ssl_cache ssl_ciphersuites
    ssl_client ssl_cookie ssl_debug_helpers_generated ssl_msg
    ssl_ticket ssl_tls ssl_tls12_client ssl_tls12_server
    ssl_tls13_client ssl_tls13_generic ssl_tls13_keys ssl_tls13_server
    threading timing version_features x509 x509_create x509_crl
    x509_crt x509_csr x509write x509write_crt x509write_csr)
list(TRANSFORM SRC_MBED PREPEND "mbedtls/")
set(SRC_TLS ncbi_gnutls ncbi_mbedtls ncbi_tls ${SRC_MBED})

set(SRC_C
    ncbi_ansi_ext ncbi_types ncbi_core ncbi_priv ncbi_util
    ncbi_buffer ncbi_socket ncbi_connector ncbi_connection
    ncbi_connutil ncbi_ipv6 ncbi_server_info ncbi_host_info
    ncbi_service ncbi_sendmail ncbi_base64 ncbi_heapmgr ncbi_lb
    ncbi_socket_connector ncbi_file_connector ncbi_http_connector
    ncbi_memory_connector ncbi_service_connector ncbi_ftp_connector
    ncbi_version ncbi_iprange ncbi_local ncbi_lbsmd ncbi_dispd
    ncbi_linkerd ncbi_namerd parson
    ncbi_localip ncbi_lbdns
    ${lbsm_src}
    )

set(SRC_CXX
    ncbi_socket_cxx ncbi_core_cxx email_diag_handler
    ncbi_conn_streambuf ncbi_conn_stream ncbi_conn_test
    ncbi_misc ncbi_namedpipe ncbi_namedpipe_connector
    ncbi_pipe ncbi_pipe_connector ncbi_conn_reader_writer
    ncbi_userhost ncbi_http_session ncbi_monkey
    ncbi_service_cxx ncbi_localip_cxx ncbi_blowfish ncbi_usage_report
    connect_misc
    ${SRC_TLS}
    )

NCBI_disable_pch()
NCBI_add_library(connssl connect xxconnect xxconnect2 xconnect xthrserv xconnsftp)
NCBI_add_subdirectory(services ext test)

=== c++/src/corelib/CMakeLists.txt ===
# $Id: CMakeLists.txt 682694 2024-05-07 12:28:56Z grichenk $

NCBI_project_tags(core)
NCBI_add_library(corelib test_mt test_boost)
NCBI_add_subdirectory(test)
NCBI_add_subdirectory(jaeger)
NCBI_add_subdirectory(opentelemetry)

=== c++/src/html/CMakeLists.txt ===
# $Id: CMakeLists.txt 621588 2020-12-14 19:26:57Z ivanov $

NCBI_project_tags(web)
NCBI_add_library(html)
NCBI_add_subdirectory(test demo)

=== c++/src/misc/CMakeLists.txt ===
# $Id: CMakeLists.txt 640800 2021-11-18 14:24:05Z stakhovv $

NCBI_add_subdirectory(
  clog 
  grid_cgi 
  xmlwrapp 
  eutils_client 
  hydra_client 
  discrepancy
  xmlreaders 
  hgvs 
  netstorage 
  jsonwrapp 
  biosample_util 
  data_loaders_util
  lapackwrapp 
  cgi_redirect 
  pmcidconv_client 
  third_party 
  third_party_static
)

=== c++/src/objects/CMakeLists.txt ===
# $Id: CMakeLists.txt 675852 2023-12-04 14:24:20Z gouriano $

NCBI_add_subdirectory(
  access
  biblio
  biotree
  blast
  blastdb
  blastxml
  blastxml2
  cdd
  cn3d
  coords
  dbsnp
  docsum
  entrez2
  entrezgene
  featdef
  gbproj
  gbseq
  general
  genesbyloc
  genomecoll
  homologene
  id1
  id2
  insdseq
  macro
  medlars
  medline
  mim
  mmdb
  ncbimime
  objprt
  omssa
  pcassay
  pcassay2
  pcsubstance
  proj
  pub
  pubmed
  remap
  scoremat
  seq
  seqcode
  seqedit
  seqset
  seqsplit
  seqtest
  submit
  taxon1
  taxon3
  tinyseq
  trackmgr
  valerr
  valid
  variation
  variation_libs
  varrep
)

=== c++/src/objmgr/CMakeLists.txt ===
# $Id: CMakeLists.txt 621735 2020-12-16 15:47:41Z ivanov $

NCBI_add_library(objmgr)
NCBI_add_subdirectory(test util split)

=== c++/src/objtools/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: CMakeLists.txt 680762 2024-03-27 13:50:01Z ivanov $
+# $Id: CMakeLists.txt 675286 2023-11-17 17:35:01Z gotvyans $
 
 NCBI_add_subdirectory(
   unit_test_util readers blast lds2 data_loaders simple

=== c++/src/algo/blast/CMakeLists.txt ===
# $Id: CMakeLists.txt 643921 2022-01-19 19:55:53Z fukanchi $

set(SRC_BLAST_C_CORE
    ../core/aa_ungapped
    ../core/blast_aalookup
    ../core/blast_aascan
    ../core/blast_diagnostics
    ../core/blast_dynarray
    ../core/blast_encoding
    ../core/blast_engine
    ../core/blast_extend
    ../core/blast_filter
    ../core/blast_gapalign
    ../core/blast_hits
    ../core/blast_hspstream
    ../core/blast_hspstream_mt_utils
    ../core/blast_itree
    ../core/blast_kappa
    ../core/blast_lookup
    ../core/blast_message
    ../core/blast_nalookup
    ../core/blast_nascan
    ../core/blast_options
    ../core/blast_parameters
    ../core/blast_posit
    ../core/blast_program
    ../core/blast_psi
    ../core/blast_psi_priv
    ../core/blast_query_info
    ../core/blast_seg
    ../core/blast_seqsrc
    ../core/blast_setup
    ../core/blast_stat
    ../core/blast_sw
    ../core/blast_traceback
    ../core/blast_traceback_mt_priv
    ../core/blast_tune
    ../core/blast_util
    ../core/boost_erf
    ../core/gapinfo
    ../core/gencode_singleton
    ../core/greedy_align
    ../core/hspfilter_besthit
    ../core/hspfilter_collector
    ../core/hspfilter_culling
    ../core/hspfilter_mapper
    ../core/index_ungapped
    ../core/jumper
    ../core/link_hsps
    ../core/lookup_util
    ../core/lookup_wrap
    ../core/matrix_freq_ratios
    ../core/na_ungapped
    ../core/ncbi_math
    ../core/ncbi_std
    ../core/pattern
    ../core/phi_extend
    ../core/phi_gapalign
    ../core/phi_lookup
    ../core/split_query
    ../core/spliced_hits
)

NCBI_add_subdirectory(
  composition_adjustment core dbindex dbindex_search api proteinkmer
  format blastinput blast_sra_input igblast gumbel_params vdb unit_tests
)

NCBI_project_watchers(camacho madden fongah2)

=== c++/src/algo/dustmask/CMakeLists.txt ===
# $Id: CMakeLists.txt 621774 2020-12-16 19:29:59Z ivanov $

NCBI_add_library(xalgodustmask)

=== debian/changelog ===
ncbi-blast+ (2.17.0+ds-6) unstable; urgency=medium

  * debian/patches/support_x32: Unbreak 64-bit builds.

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 17 Oct 2025 11:26:19 -0400

ncbi-blast+ (2.17.0+ds-5) unstable; urgency=medium

  * debian/patches/support_x32: Fix wgsread.cpp for 32-bit architectures.
    (Closes: #1117023.)

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 17 Oct 2025 10:12:47 -0400

ncbi-blast+ (2.17.0+ds-4) unstable; urgency=medium

  * debian/patches/support_x32: Correctly broaden configure(.ac)'s VDB
    allow-list.  (Closes: #1117023.)

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 16 Oct 2025 17:24:56 -0400

ncbi-blast+ (2.17.0+ds-3) unstable; urgency=medium

  * debian/control: Restrict armv8crc-support dependency to arm64.
  * debian/patches/support_x32: Slightly broaden configure(.ac)'s VDB
    allow-list.  (Closes: #1117023.)
  * debian/patches/zcf-simde-crc32c: Leave CFLAGS alone on 32-bit ARM;
    adjustments aren't actually worthwhile there and would have needed to
    go further on armhf, on which (at least under GCC) ARMv8 targets
    additionally need +simd.  (Closes: #1117022.)

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 16 Oct 2025 16:15:12 -0400

ncbi-blast+ (2.17.0+ds-2) unstable; urgency=medium

  * debian/control:
    - Additionally build-depend on libsimde-dev.
    - Require CRC support on ARM per upstream.
  * debian/patches/zcf-simde-crc32c (new): Replace Cloudflare deflate.c's
    fallbackless architecture-dependent code with a SIMDE invocation that
    amounts to the same thing on supported architectures and to a portable
    fallback elsewhere.

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 01 Oct 2025 14:43:25 -0400

ncbi-blast+ (2.17.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    - Require SSE 4.2 on x86 per upstream.
    - Reformat via "cme fix dpkg-control" (routine-update).
  * debian/copyright:
    - Update with more help from lrc.
    - Clean up whitespace (routine-update).
  * debian/ncbi-blast+.lintian-overrides: Override embedded-library zlib
    for libzcf.so, which is Cloudflare's fork.
  * debian/patches: Update for new release, mostly formally.
  * debian/patches/series: Comment out support_mbedtls3, allow_pcre2,
    and fix_bm_for_gcc15, all incorporated upstream.
  * debian/patches/system_mbedtls_only: Drop code changes (incorporated
    upstream) and port Makefile.connssl.lib's changes.
  * debian/rules: Explicitly supply VDB_LIBDIR to configure to avoid a bad
    interaction that led to spurious runpath entries in binaries linked
    against VDB.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 28 Sep 2025 23:08:59 -0400

=== debian/control ===
Source: ncbi-blast+
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Olivier Sallou <osallou@debian.org>,
 Andreas Tille <tille@debian.org>,
 Aaron M. Ucko <ucko@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 autoconf2.69,
Build-Depends-Arch:
 libboost-test-dev,
 libbz2-dev,
 libc-dev-bin,
 libgnutls28-dev,
 liblmdb-dev,
 libmbedtls-dev,
 libncbi-vdb-dev [amd64 arm64 x32],
 libnghttp2-dev,
 libpcre2-dev,
 libsimde-dev,
 libsqlite3-dev,
 libuv1-dev,
 time,
 zlib1g-dev,
 procps,
Vcs-Browser: https://salsa.debian.org/med-team/ncbi-blastplus
Vcs-Git: https://salsa.debian.org/med-team/ncbi-blastplus.git
Homepage: https://www.ncbi.nlm.nih.gov/IEB/ToolBox/CPP_DOC/
Rules-Requires-Root: no

Package: ncbi-blast+
Architecture: any
Multi-Arch: foreign
Depends:
 armv8crc-support [arm64],
 ncbi-data,
 python3,
 sse4.2-support [any-amd64 any-i386 any-x32],
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Enhances:
 t-coffee,
Description: next generation suite of BLAST sequence search tools
 The Basic Local Alignment Search Tool (BLAST) is the most widely
 used sequence similarity tool. There are versions of BLAST that
 compare protein queries to protein databases, nucleotide queries
 to nucleotide databases, as well as versions that translate nucleotide
 queries or databases in all six frames and compare to protein databases
 or queries.
 PSI-BLAST produces a position-specific-scoring-matrix (PSSM) starting
 with a protein query, and then uses that PSSM to perform further searches.
 It is also possible to compare a protein or nucleotide query to a
 database of PSSM’s.
 The NCBI supports a BLAST web page at blast.ncbi.nlm.nih.gov as well as
 a network service.

Package: ncbi-blast+-legacy
Architecture: all
Multi-Arch: foreign
Depends:
 ncbi-blast+,
 ${misc:Depends},
Description: NCBI Blast legacy call script
 This package adds some fake scripts to call NCBI+ programs
 with the NCBI blast command line. It makes use of the
 legacy_blast script in ncbi-blast+ package.

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\///;s/\+-src/-orig/;s/blast/blast+/,dversionmangle=s/\+ds//,repacksuffix=+ds \
     https://ftp.ncbi.nlm.nih.gov/blast/executables/blast+/LATEST/ncbi-blast-(.*)\+-src\.tar\.gz debian uupdate
